/**
 * This file is part of
 * 
 * Repast Simphony MySQL Database Outputter
 *
 * Copyright (C) 2012 Argonne National Laboratory
 * Copyright (C) 2013 Center for Environmental Systems Research, Kassel, Germany
 * 
 * Repast Simphony MySQL Database Outputter is free software; you can redistribute 
 * it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; If not, see <http://www.gnu.org/licenses/>.
 * 
 * Center for Environmental Systems Research, Kassel
 * Created by Sascha Holzhauer on 13.04.2010
 */
package repast.simphony.data.db.outputter.gui;



import repast.simphony.data.db.outputter.engine.DbOutputterComponentControllerAction;
import repast.simphony.data.db.outputter.engine.DbOutputterDescriptor;
import repast.simphony.ui.plugin.ActionEditorCreator;
import repast.simphony.ui.plugin.ActionUI;



/**
 * repast.simphony.data.db
 * 
 * createEditor returns a {@link DbOutputterDescriptorActionUI}.
 * 
 * @author Sascha Holzhauer
 * @date 13.04.2010
 * 
 */
public class DbActionEditorCreator implements
		ActionEditorCreator<DbOutputterComponentControllerAction<DbOutputterDescriptor>> {

	/**
	 * Returns a {@link DbOutputterDescriptorActionUI}
	 * @see repast.simphony.ui.plugin.ActionEditorCreator#createEditor(repast.simphony.engine.environment.ControllerAction)
	 */
	@Override
	public ActionUI createEditor(DbOutputterComponentControllerAction<DbOutputterDescriptor> action) {
		return new DbOutputterDescriptorActionUI(action);
	}

	/**
	 * @see repast.simphony.ui.plugin.ActionEditorCreator#getActionType()
	 */
	@Override
	public Class<?> getActionType() {
		return DbOutputterComponentControllerAction.class;
	}
}
